/*
 * Copyright (C) 1996 Thomas 'Mike' Michlmayr
 */

#ifndef KEYMAP_H
#define KEYMAP_H

typedef struct keymap KEYMAP;
struct keymap {
  KEYMAP *next;
  short menu;
  short function;
};

#define MAX_KEYS        128

extern KEYMAP *Keymap[MAX_KEYS];

/* keymap.c */
void keymap_init (void);
int  keymap_lookup (int, int);
void keymap_done (void);
void keymap_bind (char, int, int);

#define MENU_MAIN       0
#define MENU_PAGER      1
#define MENU_ATTACH     2
#define MENU_FOLDER     3
#define MENU_ALIAS      4
#define MENU_SEND       5
#define MENU_REMAILER   6
#define MENU_POST       7

/*
 * Copyright (C) 1996 Michael R. Elkins <me@cs.hmc.edu>
 */

#include "keymap_defs.h"

struct binding_t {
  char *name;
  short op;
};

#ifndef KEYMAP_GLOBAL_C
extern struct binding_t Op_generic[];
extern struct binding_t Op_attach[];
extern struct binding_t Op_pager[];
extern struct binding_t Op_main[];
extern struct binding_t Op_send[];
#endif /* KEYMAP_GLOBAL_C */

#endif /* KEYMAP_H */
