/* Copyright (C) 1996 Michael R. Elkins.
 * 
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 * 
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */ 

#include "mutt.h"
#include "rfc822.h"

#ifdef HAVE_LIBGEN
#include <libgen.h>
#endif

#ifdef HAVE_REGEX_H
#include <regex.h>
#endif

#ifdef HAVE_REGEX
#define MATCHES(x) regex(re, x)
#elif HAVE_RE_EXEC
#define MATCHES(x) re_exec(x)
#else
static int fake_regexp (char *pat, char *s)
{
  int len = strlen(pat);

  while (*s) {
    if (strncasecmp(s, pat, len) == 0) return(1);
    s++;
  }
  return(0);
}
#define MATCHES(x) fake_regexp(buf, x)
#endif

/*
** Recurrent search - modified by pms@romance.kaist.ac.kr
*/
void ci_search_command (void)
{
  int i, j;
  char buf[STRING], frombuf[STRING];
#ifdef HAVE_REGEX
  char *re;
#endif

  buf[0] = 0;
  ci_get_field("Search for: ", buf, 0, 0);
  if(!buf[0]) buf[0] = 0x20;

#ifdef HAVE_REGEX
  re = regcmp(buf, 0);
#elif HAVE_RE_EXEC
  re_comp(buf);
#endif
  
  for (i=Context->current + 1, j=0; j!=Context->vcount; i++, j++) {
    if (Context->hdrs[i]->subject && MATCHES(Context->hdrs[i]->subject)) {
      Context->current = i;
      return;
    }

    frombuf[0] = 0;
    rfc822_write_address(frombuf, Context->hdrs[i]->from);
    if (MATCHES(frombuf)) {
      Context->current = i;
      return;
    }

    frombuf[0] = 0;
    rfc822_write_address(frombuf, Context->hdrs[i]->to);
    if (MATCHES(frombuf)) {
      Context->current = i;
      return;
    }

	if(i==Context->vcount-1) i = -1;
  }
  mutt_error("Not found.");
}
